﻿using System;
using System.Windows;

namespace TestProject
{
    /// <summary>
    /// 메인 애플리케이션
    /// </summary>
    public partial class MainApplication : Application
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 스킨 - Skin

        /// <summary>
        /// 스킨
        /// </summary>
        public static Skin Skin { get; set; } = Skin.Red;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 스킨 변경하기 - ChangeSkin(Skin skin)

        /// <summary>
        /// 스킨 변경하기
        /// </summary>
        /// <param name="skin">스킨</param>
        public void ChangeSkin(Skin skin)
        {
            Skin = skin;

            Resources.Clear();

            Resources.MergedDictionaries.Clear();

            if(Skin == Skin.Blue)
            {
                AddBlueSkin();
            }
            else if(Skin == Skin.Red)
            {
                AddRedSkin();
            }

            AddBorderStyle();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Protected

        #region 시작시 처리하기 - OnStartup(e)

        /// <summary>
        /// 시작시 처리하기
        /// </summary>
        /// <param name="e">이벤트 인자</param>
        protected override void OnStartup(StartupEventArgs e)
        {
            base.OnStartup(e);

            ChangeSkin(Skin.Red);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region 리소스 딕셔너리 추가하기 - AddResourceDictionary(uri)

        /// <summary>
        /// 리소스 딕셔너리 추가하기
        /// </summary>
        /// <param name="uri">URI</param>
        private void AddResourceDictionary(string uri)
        {
            Resources.MergedDictionaries.Add
            (
                new ResourceDictionary()
                {
                    Source = new Uri(uri, UriKind.Relative)
                }
            );
        }

        #endregion

        #region 청색 스킨 추가하기 - AddBlueSkin()

        /// <summary>
        /// 청색 스킨 적용하기
        /// </summary>
        private void AddBlueSkin()
        {
            AddResourceDictionary("RESOURCE/BlueColor.xaml");
            AddResourceDictionary("RESOURCE/BlueSize.xaml" );
        }

        #endregion
        #region 적색 스킨 추가하기 - AddRedSkin()

        /// <summary>
        /// 적색 스킨 추가하기
        /// </summary>
        private void AddRedSkin()
        {
            AddResourceDictionary("RESOURCE/RedColor.xaml");
            AddResourceDictionary("RESOURCE/RedSize.xaml" );
        }

        #endregion

        #region 테두리 스타일 추가하기 - AddBorderStyle()

        /// <summary>
        /// 테두리 스타일 추가하기
        /// </summary>
        private void AddBorderStyle()
        {
            AddResourceDictionary("RESOURCE/BorderStyle.xaml");
        }

        #endregion
    }
}