﻿using System.Windows;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.blueSkinButton.Click += blueSkinButton_Click;
            this.redSkinButton.Click  += redSkinButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 청색 스킨 버튼 클릭시 처리하기 - blueSkinButton_Click(sender, e)

        /// <summary>
        /// 청색 스킨 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void blueSkinButton_Click(object sender, RoutedEventArgs e)
        {
            (Application.Current as MainApplication).ChangeSkin(Skin.Blue);
        }

        #endregion
        #region 적색 스킨 버튼 클릭시 처리하기 - redSkinButton_Click(sender, e)

        /// <summary>
        /// 적색 스킨 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void redSkinButton_Click(object sender, RoutedEventArgs e)
        {
            (Application.Current as MainApplication).ChangeSkin(Skin.Red);
        }

        #endregion
    }
}